<template>
  <a-card :bordered="false">
    <!-- 查询区域 -->
    <div class="table-page-search-wrapper">
      <a-form layout="inline" @keyup.enter.native="searchQuery">
        <a-row :gutter="24">
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <a-form-item label="委托单位名称">
              <j-search-select-tag placeholder="请选择委托单位名称" v-model="queryParam.weituoClient"  :dictOptions="weituoClientList" @change="handlewcChange"/>
              <!--              <a-input placeholder="请输入委托单位名称" v-model="queryParam.weituoClient"></a-input>-->
            </a-form-item>
          </a-col>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <a-form-item label="委托编号">
              <j-search-select-tag placeholder="请选择委托编号" v-model="queryParam.weituoNo" :dictOptions="weituoNoOptions"/>
            </a-form-item>
          </a-col>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <span style="float: left;overflow: hidden;" class="table-page-search-submitButtons">
              <a-button type="primary" @click="searchQuery" icon="search">查询</a-button>
              <a-button type="primary" @click="searchReset" icon="reload" style="margin-left: 8px">重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!-- 查询区域-END -->

    <!-- 操作按钮区域 -->
<!--    <div class="table-operator">-->
<!--      <a-button @click="handleAdd" type="primary" icon="plus">新增</a-button>-->
<!--      <a-button type="primary" icon="download" @click="handleExportXls('委托信息')">导出</a-button>-->
<!--      <a-upload name="file" :showUploadList="false" :multiple="false" :headers="tokenHeader" :action="importExcelUrl" @change="handleImportExcel">-->
<!--        <a-button type="primary" icon="import">导入</a-button>-->
<!--      </a-upload>-->
<!--      &lt;!&ndash; 高级查询区域 &ndash;&gt;-->
<!--      <j-super-query :fieldList="superFieldList" ref="superQueryModal" @handleSuperQuery="handleSuperQuery"></j-super-query>-->
<!--      <a-dropdown v-if="selectedRowKeys.length > 0">-->
<!--        <a-menu slot="overlay">-->
<!--          <a-menu-item key="1" @click="batchDel"><a-icon type="delete"/>删除</a-menu-item>-->
<!--        </a-menu>-->
<!--        <a-button style="margin-left: 8px"> 批量操作 <a-icon type="down" /></a-button>-->
<!--      </a-dropdown>-->
<!--    </div>-->

    <!-- table区域-begin -->
    <div>
<!--      <div class="ant-alert ant-alert-info" style="margin-bottom: 16px;">-->
<!--        <i class="anticon anticon-info-circle ant-alert-icon"></i> 已选择 <a style="font-weight: 600">{{ selectedRowKeys.length }}</a>项-->
<!--        <a style="margin-left: 24px" @click="onClearSelected">清空</a>-->
<!--      </div>-->

      <a-table
        ref="table"
        size="middle"
        :scroll="{x:true}"
        bordered
        rowKey="id"
        :columns="columns"
        :dataSource="dataSource"
        :pagination="ipagination"
        :loading="loading"
        class="j-table-force-nowrap"
        @change="handleTableChange">

        <template slot="htmlSlot" slot-scope="text">
          <div v-html="text"></div>
        </template>
        <template slot="imgSlot" slot-scope="text,record">
          <span v-if="!text" style="font-size: 12px;font-style: italic;">无图片</span>
          <img v-else :src="getImgView(text)" :preview="record.id" height="25px" alt="" style="max-width:80px;font-size: 12px;font-style: italic;"/>
        </template>
        <template slot="fileSlot" slot-scope="text">
          <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
          <a-button
            v-else
            :ghost="true"
            type="primary"
            icon="download"
            size="small"
            @click="downloadFile(text)">
            下载
          </a-button>
        </template>

        <span slot="action" slot-scope="text, record">
          <a-popconfirm :title="record.completeStatus == 0 ? '确定该委托项目已完结吗，完结后不可修改': '该委托项目已完结，不可修改'" @confirm="() => handleWancheng(record)">
            <a>{{record.completeStatus == 0 ? '未完结': '已完结'}}</a>
          </a-popconfirm>
        </span>

      </a-table>
    </div>

    <itdm-weituo-info-modal ref="modalForm" @ok="modalFormOk"></itdm-weituo-info-modal>
  </a-card>
</template>

<script>

import '@/assets/less/TableExpand.less'
import { mixinDevice } from '@/utils/mixin'
import { JeecgListMixin } from '@/mixins/JeecgListMixin'
import ItdmWeituoInfoModal from './modules/ItdmWeituoInfoModal'
import { ajaxGetDictItems, loadCategoryData } from '@/api/api'
import { filterMultiDictText } from '@comp/dict/JDictSelectUtil'
import { getAction } from '@api/manage'
import { checkWancheng, getWeituoInfoListByClient } from '@/api/api'



export default {
  name: 'ItdmWeituoInfoWanchengList',
  mixins:[JeecgListMixin, mixinDevice],
  components: {
    ItdmWeituoInfoModal
  },
  data () {
    return {
      queryParam: {
        weituoClient: undefined,
        weituoNo: undefined
      },
      weituoClientList:[],
      weituoNoOptions: [],
      description: '委托信息管理页面',
      // 表头
      columns: [
        // {
        //   title: '#',
        //   dataIndex: '',
        //   key:'rowIndex',
        //   width:60,
        //   align:"center",
        //   customRender:function (t,r,index) {
        //     return parseInt(index)+1;
        //   }
        // },
        {
          title:'委托编号',
          align:"center",
          dataIndex: 'weituoNo',
          customRender: (value, row, index) => {
            console.log(value, row, index)
            const obj = {
              children: value,
              attrs: {},
            };
            let arr = this.dataSource.filter((res) => {
              return res.weituoNo == row.weituoNo;
            });
            // 当是第一行时，就给rowSpan是arr数组的长度
            // 如果不将index=0时单独做判断，会导致this.dataSource[index-1]报错，从而导致第一行数据显示错位，没有合并单元格，不显示委托单号
            // 因为每页的第一行数据并没有上一条数据去与之做对比，所以可以默认委托单号不相等(个人感觉)
            // 如果当前不是第一行数据，则按照之前的逻辑进行判断即可  （个人想到的解决方案，不知道是否合理，但是问题是解决了，前端开发时可以随时更正）
            if(index == 0){
              obj.attrs.rowSpan = arr.length
            }else {
              if(row.weituoNo !== this.dataSource[index - 1].weituoNo){
                obj.attrs.rowSpan = arr.length
              } else {
                obj.attrs.rowSpan = 0
              }
            }

            return obj
          },
        },
        {
          title:'委托单位名称',
          align:"center",
          dataIndex: 'weituoClient'
        },
        {
          title:'试验项目',
          align:"center",
          dataIndex: 'testItems'
        },
        {
          title:'样品名称',
          align:"center",
          dataIndex: 'sampleName'
        },
        {
          title:'项目经理',
          align:"center",
          dataIndex: 'pm'
        },
        {
          title:'项目进度',
          align:"center",
          dataIndex: 'weituoStep'
        },

        // {
        //   title:'委托单位地址',
        //   align:"center",
        //   dataIndex: 'weituoAddress'
        // },
        // {
        //   title:'委托项目状态',
        //   align:"center",
        //   dataIndex: 'completeStatus_dictText'
        // },
        // {
        //   title:'委托联系人',
        //   align:"center",
        //   dataIndex: 'weituoLxr'
        // },
        // {
        //   title:'委托电话',
        //   align:"center",
        //   dataIndex: 'weituoPhone'
        // },
        {
          title: '操作',
          dataIndex: 'action',
          align:"center",
          fixed:"right",
          width:147,
          scopedSlots: { customRender: 'action' }
        }
      ],
      url: {
        list: "/weituo/itdmWeituoInfo/list1",
        delete: "/weituo/itdmWeituoInfo/delete",
        deleteBatch: "/weituo/itdmWeituoInfo/deleteBatch",
        exportXlsUrl: "/weituo/itdmWeituoInfo/exportXls",
        importExcelUrl: "weituo/itdmWeituoInfo/importExcel",

      },
      dictOptions:{},
      superFieldList:[],
      weituoInfoForm:{},
    }
  },
  created() {
    this.getSuperFieldList();
    this.init()
  },
  computed: {
    importExcelUrl: function(){
      return `${window._CONFIG['domianURL']}/${this.url.importExcelUrl}`;
    },
  },
  methods: {

    init(){

      getAction('/weituo/itdmWeituoInfo/distinctClientList', {}).then((res) => {
        if (res.success) {
          console.log(res.result)
          this.weituoClientList = res.result.map(i=>{
            return { value: i, text: i}
          })
          console.log(this.weituoClientList)
        }
      })


    },


    initDictConfig(){
      ajaxGetDictItems('weituo.bgyz').then((res) => {
        if (res.success) {
          console.log(res.result)
          this.$set(this.dictOptions, 'bgyz', res.result)
        }
      })
      ajaxGetDictItems('weituo.bgxs').then((res) => {
        if (res.success) {
          console.log(res.result)
          this.$set(this.dictOptions, 'bgxs', res.result)
        }
      })
    },
    getSuperFieldList(){
      let fieldList=[];
      fieldList.push({type:'string',value:'weituoClient',text:'委托单位名称',dictCode:''})
      fieldList.push({type:'string',value:'weituoAddress',text:'委托单位地址',dictCode:''})
      fieldList.push({type:'string',value:'weituoLxr',text:'委托联系人',dictCode:''})
      fieldList.push({type:'string',value:'weituoPhone',text:'委托电话',dictCode:''})
      fieldList.push({type:'string',value:'weituoEmail',text:'委托邮箱',dictCode:''})
      fieldList.push({type:'string',value:'bgyz',text:'报告用章'})
      fieldList.push({type:'string',value:'bgxs',text:'报告形式'})
      fieldList.push({type:'string',value:'teshuyaoqiu',text:'特殊要求',dictCode:''})
      fieldList.push({type:'string',value:'tiaojianFile',text:'试验条件文件地址',dictCode:''})
      this.superFieldList = fieldList
    },

    handleWancheng(item){
      console.log("item",item,item.completeStatus)
      const _this = this
      _this.weituoInfoForm = JSON.parse(JSON.stringify(item))
      // _this.weituoInfoForm = item
      console.log(_this.weituoInfoForm,_this.weituoInfoForm.completeStatus)
      if(item.completeStatus == 0){
        _this.weituoInfoForm.completeStatus = 1
        // console.log(_this.deviceForm,item)
        checkWancheng(_this.weituoInfoForm).then((res) => {
          console.log(res)
          this.loadData();
        })
      }
    },
    // 监听选中委托单位，获取该单位的委托编号
    handlewcChange(data){
      console.log(data)
      this.weituoNoOptions = []
      this.queryParam.weituoNo = undefined
      getWeituoInfoListByClient(this.queryParam).then((res) =>{
        console.log(res.result)
        this.weituoNoOptions = res.result.map( res => {
          return {
            value: res.weituoNo,  //传的值
            text: res.weituoNo  //展示
          }
        })
        console.log(this.weituoNoOptions)
      })
    },
  }
}
</script>
<style scoped>
@import '~@assets/less/common.less';
</style>